Finisher = {};

function Finisher.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function Finisher:load(xmlFile)

        assert(self.setIsTurneOn == nil, "Finisher needs to be the first specialization which implements setIsTurneOn");
        self.setIsTurneOn = Finisher.setIsTurneOn;

        self.animTime = 0;

        self.rotors = {};

	self.rotationMaxRight = true;
	self.rotationMaxLeft = true;
	self.rotationMaxRight2 = true;
	self.rotationMaxLeft2 = true;
	self.translationMax = true;
	self.translationMax2 = true;
	self.translationMin3 = true;
	

	
	self.anim = SpecializationUtil.callSpecializationsFunction("anim");
  	self.charId = {};
	self.clipIndex = {};
	self.Go = {};
	self.Done = {};
	self.CheckDone = {};
	local count = getXMLInt(xmlFile, "vehicle.animParts#count");
    self.animParts = {}
	local part = self.animParts;
    for i=1, count do
		part[i] = {};
        local partname = string.format("vehicle.animParts.part".."%d", i);
	    local nameR = getXMLString(xmlFile, partname.."#name");
		self.charId[nameR] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partname.."#rootNode"));
		self.clipIndex[nameR] = getXMLString(xmlFile, partname.."#animationClip");
		self.CheckDone[nameR] = false;

	end;
	
	    local motoSound = getXMLString(xmlFile, "vehicle.motoSound#file");
       if motoSound ~= nil and motoSound ~= "" then
           motoSound = Utils.getFilename(motoSound, self.baseDirectory);
           self.motoSound = createSample("motoSound");
           loadSample(self.motoSound, motoSound, false);
           self.motoSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#pitchOffset"), 0);
           self.motoSoundPitchScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#pitchScale"), 0.05);
           self.motoSoundPitchMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#pitchMax"), 2.0);
           self.motoSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#volume"), 1.0);
           self.motoSoundEnabled = false;
       end;
       
	   	self.regime = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.regime#index"));
 		self.regime2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.regime2#index"));

	
	local i=0;
        while true do
            local baseName = string.format("vehicle.rotors.rotor(%d)", i);
            local node = {};
            node.index = getXMLString(xmlFile, baseName.. "#index");
            local direction = Utils.getNoNil(getXMLInt(xmlFile, baseName.. "#direction"), 1);
           node.speed = direction*Utils.getNoNil(getXMLFloat(xmlFile, baseName.. "#speed"), -0.008);
            if node.index == nil then
                break;
            end;
            node.index = Utils.indexToObject(self.components, node.index);
            if node.index ~= nil then
                table.insert(self.rotors, node);
            end;
            i = i+1;
        end;
	
	self.Roadparts = {};
    local i = 0;
    while true do
        local namei = string.format("vehicle.Roadparts.Roadpart(%d)", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
		local enrobe = getXMLString(xmlFile, namei .. "#enrobe");
		if (nodei and enrobe) == nil then
			break;
		end;
		self.Roadparts[i] = {}
		self.Roadparts[i].ps = {}
        Utils.loadParticleSystem(xmlFile, self.Roadparts[i].ps, namei, nodei, false, nil, self.baseDirectory);
		self.Roadparts[i].isActive = Utils.getNoNil(getXMLBool(xmlFile, namei .. "#isActive"), true);
		self.Roadparts[i].node = nodei;
		self.Roadparts[i].enrobe = enrobe;
		self.Roadparts[i].distance = Utils.getNoNil(getXMLString(xmlFile, namei .. "#distance"), 0.1);
		self.Roadparts[i].createRoad = false;
		self.Roadparts[i].LastCreatedGround = nil;
		i = i+1;
    end;
    
    self.Roadpars = {};
    local i = 0;
    while true do
        local namei = string.format("vehicle.Roadpars.Roadpar(%d)", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
		local enrobe = getXMLString(xmlFile, namei .. "#enrobe");
		if (nodei and enrobe) == nil then
			break;
		end;
		self.Roadpars[i] = {}
		self.Roadpars[i].ps = {}
        Utils.loadParticleSystem(xmlFile, self.Roadpars[i].ps, namei, nodei, false, nil, self.baseDirectory);
		self.Roadpars[i].isActive = Utils.getNoNil(getXMLBool(xmlFile, namei .. "#isActive"), true);
		self.Roadpars[i].node = nodei;
		self.Roadpars[i].enrobe = enrobe;
		self.Roadpars[i].distance = Utils.getNoNil(getXMLString(xmlFile, namei .. "#distance"), 0.1);
		self.Roadpars[i].createRoad = false;
		self.Roadpars[i].LastCreatedGround = nil;
		i = i+1;
    end;
        self.Roadpas = {};
    local i = 0;
    while true do
        local namei = string.format("vehicle.Roadpas.Roadpa(%d)", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
		local enrobe = getXMLString(xmlFile, namei .. "#enrobe");
		if (nodei and enrobe) == nil then
			break;
		end;
		self.Roadpas[i] = {}
		self.Roadpas[i].ps = {}
        Utils.loadParticleSystem(xmlFile, self.Roadpas[i].ps, namei, nodei, false, nil, self.baseDirectory);
		self.Roadpas[i].isActive = Utils.getNoNil(getXMLBool(xmlFile, namei .. "#isActive"), true);
		self.Roadpas[i].node = nodei;
		self.Roadpas[i].enrobe = enrobe;
		self.Roadpas[i].distance = Utils.getNoNil(getXMLString(xmlFile, namei .. "#distance"), 0.1);
		self.Roadpas[i].createRoad = false;
		self.Roadpas[i].LastCreatedGround = nil;
		i = i+1;
    end;
        self.Roadps = {};
    local i = 0;
    while true do
        local namei = string.format("vehicle.Roadps.Roadp(%d)", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
		local enrobe = getXMLString(xmlFile, namei .. "#enrobe");
		if (nodei and enrobe) == nil then
			break;
		end;
		self.Roadps[i] = {}
		self.Roadps[i].ps = {}
        Utils.loadParticleSystem(xmlFile, self.Roadps[i].ps, namei, nodei, false, nil, self.baseDirectory);
		self.Roadps[i].isActive = Utils.getNoNil(getXMLBool(xmlFile, namei .. "#isActive"), true);
		self.Roadps[i].node = nodei;
		self.Roadps[i].enrobe = enrobe;
		self.Roadps[i].distance = Utils.getNoNil(getXMLString(xmlFile, namei .. "#distance"), 0.1);
		self.Roadps[i].createRoad = false;
		self.Roadps[i].LastCreatedGround = nil;
		i = i+1;
    end;
                self.Roads = {};
    local i = 0;
    while true do
        local namei = string.format("vehicle.Roads.Road(%d)", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
		local enrobe = getXMLString(xmlFile, namei .. "#enrobe");
		if (nodei and enrobe) == nil then
			break;
		end;
		self.Roads[i] = {}
		self.Roads[i].ps = {}
        Utils.loadParticleSystem(xmlFile, self.Roads[i].ps, namei, nodei, false, nil, self.baseDirectory);
		self.Roads[i].isActive = Utils.getNoNil(getXMLBool(xmlFile, namei .. "#isActive"), true);
		self.Roads[i].node = nodei;
		self.Roads[i].enrobe = enrobe;
		self.Roads[i].distance = Utils.getNoNil(getXMLString(xmlFile, namei .. "#distance"), 0.1);
		self.Roads[i].createRoad = false;
		self.Roads[i].LastCreatedGround = nil;
		i = i+1;
    end;
    self.Roas = {};
    local i = 0;
    while true do
        local namei = string.format("vehicle.Roas.Roa(%d)", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
		local enrobe = getXMLString(xmlFile, namei .. "#enrobe");
		if (nodei and enrobe) == nil then
			break;
		end;
		self.Roas[i] = {}
		self.Roas[i].ps = {}
        Utils.loadParticleSystem(xmlFile, self.Roas[i].ps, namei, nodei, false, nil, self.baseDirectory);
		self.Roas[i].isActive = Utils.getNoNil(getXMLBool(xmlFile, namei .. "#isActive"), true);
		self.Roas[i].node = nodei;
		self.Roas[i].enrobe = enrobe;
		self.Roas[i].distance = Utils.getNoNil(getXMLString(xmlFile, namei .. "#distance"), 0.1);
		self.Roas[i].createRoad = false;
		self.Roas[i].LastCreatedGround = nil;
		i = i+1;
    end;
    

    

	local rotationPartNodeLeft = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartLeft#index"));
    if rotationPartNodeLeft ~= nil then
        self.rotationPartLeft = {};
        self.rotationPartLeft.node = rotationPartNodeLeft;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeft#minRot"));
        self.rotationPartLeft.minRot = {};
        self.rotationPartLeft.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartLeft.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartLeft.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeft#maxRot"));
        self.rotationPartLeft.maxRot = {};
        self.rotationPartLeft.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartLeft.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartLeft.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        self.rotationPartLeft.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeft#rotTime"), 100)*1000;
        self.rotationPartLeft.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeft#touchRotLimit"), 10));
    end;

	local rotationPartNodeRight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRight#index"));
    if rotationPartNodeRight ~= nil then
        self.rotationPartRight = {};
        self.rotationPartRight.node = rotationPartNodeRight;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRight#minRot"));
        self.rotationPartRight.minRot = {};
        self.rotationPartRight.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartRight.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartRight.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRight#maxRot"));
        self.rotationPartRight.maxRot = {};
        self.rotationPartRight.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartRight.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartRight.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        self.rotationPartRight.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRight#rotTime"), 100)*1000;
        self.rotationPartRight.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRight#touchRotLimit"), 10));
    end;
    
    	local rotationPartNodeLeft2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartLeft2#index"));
    if rotationPartNodeLeft2 ~= nil then
        self.rotationPartLeft2 = {};
        self.rotationPartLeft2.node = rotationPartNodeLeft2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeft2#minRot"));
        self.rotationPartLeft2.minRot = {};
        self.rotationPartLeft2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartLeft2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartLeft2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeft2#maxRot"));
        self.rotationPartLeft2.maxRot = {};
        self.rotationPartLeft2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartLeft2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartLeft2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        self.rotationPartLeft2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeft2#rotTime"), 100)*1000;
        self.rotationPartLeft2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeft2#touchRotLimit"), 10));
    end;

	local rotationPartNodeRight2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRight2#index"));
    if rotationPartNodeRight2 ~= nil then
        self.rotationPartRight2 = {};
        self.rotationPartRight2.node = rotationPartNodeRight2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRight2#minRot"));
        self.rotationPartRight2.minRot = {};
        self.rotationPartRight2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartRight2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartRight2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRight2#maxRot"));
        self.rotationPartRight2.maxRot = {};
        self.rotationPartRight2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartRight2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartRight2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        self.rotationPartRight2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRight2#rotTime"), 100)*1000;
        self.rotationPartRight2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRight2#touchRotLimit"), 10));
    end;
    local translationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart#index"));
    if translationPartNode ~= nil then
        self.translationPart = {};
        self.translationPart.node = translationPartNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#minTrans"));
        self.translationPart.minTrans = {};
        self.translationPart.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#maxTrans"));
        self.translationPart.maxTrans = {};
        self.translationPart.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#transTime"), 2)*1000;
        self.translationPart.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#touchTransLimit"), 10);
    end;
	local translationPartNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart2#index"));
    if translationPartNode2 ~= nil then
        self.translationPart2 = {};
        self.translationPart2.node = translationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#minTrans"));
        self.translationPart2.minTrans = {};
        self.translationPart2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#maxTrans"));
        self.translationPart2.maxTrans = {};
        self.translationPart2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#transTime"), 2)*1000;
        self.translationPart2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#touchTransLimit"), 10);
    end;
    local translationPartNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart3#index"));
    if translationPartNode3 ~= nil then
        self.translationPart3 = {};
        self.translationPart3.node = translationPartNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart3#minTrans"));
        self.translationPart3.minTrans = {};
        self.translationPart3.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart3.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart3#maxTrans"));
        self.translationPart3.maxTrans = {};
        self.translationPart3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart3.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart3#transTime"), 2)*1000;
        self.translationPart3.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart3#touchTransLimit"), 10);
    end;
        local translationPartNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart4#index"));
    if translationPartNode4 ~= nil then
        self.translationPart4 = {};
        self.translationPart4.node = translationPartNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart4#minTrans"));
        self.translationPart4.minTrans = {};
        self.translationPart4.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart4.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart4.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart4#maxTrans"));
        self.translationPart4.maxTrans = {};
        self.translationPart4.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart4.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart4.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart4.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart4#transTime"), 2)*1000;
        self.translationPart4.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart4#touchTransLimit"), 10);
    end;
        local translationPartNode5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart5#index"));
    if translationPartNode5 ~= nil then
        self.translationPart5 = {};
        self.translationPart5.node = translationPartNode5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart5#minTrans"));
        self.translationPart5.minTrans = {};
        self.translationPart5.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart5.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart5.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart5#maxTrans"));
        self.translationPart5.maxTrans = {};
        self.translationPart5.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart5.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart5.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart5.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart5#transTime"), 2)*1000;
        self.translationPart5.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart5#touchTransLimit"), 10);
    end;
    local translationPartNode6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart6#index"));
    if translationPartNode6 ~= nil then
        self.translationPart6 = {};
        self.translationPart6.node = translationPartNode6;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart6#minTrans"));
        self.translationPart6.minTrans = {};
        self.translationPart6.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart6.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart6.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart6#maxTrans"));
        self.translationPart6.maxTrans = {};
        self.translationPart6.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart6.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart6.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart6.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart6#transTime"), 2)*1000;
        self.translationPart6.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart6#touchTransLimit"), 10);
    end;
    local translationPartNode7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart7#index"));
    if translationPartNode7 ~= nil then
        self.translationPart7 = {};
        self.translationPart7.node = translationPartNode7;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart7#minTrans"));
        self.translationPart7.minTrans = {};
        self.translationPart7.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart7.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart7.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart7#maxTrans"));
        self.translationPart7.maxTrans = {};
        self.translationPart7.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart7.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart7.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart7.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart7#transTime"), 2)*1000;
        self.translationPart7.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart7#touchTransLimit"), 10);
    end;
    
           self.isTurneOn = false;
           
        self.Routea = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Routepointa#index"));
	    self.Routeb = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Routepointb#index"));
        self.Routec = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Routepointc#index"));
	    self.Routed = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Routepointd#index"));
	    self.Routee = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Routepointe#index"));
	    self.Routef = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Routepointf#index"));




    local translationPartNode8 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart8#index"));
    if translationPartNode8 ~= nil then
        self.translationPart8 = {};
        self.translationPart8.node = translationPartNode8;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart8#minTrans"));
        self.translationPart8.minTrans = {};
        self.translationPart8.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart8.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart8.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart8#maxTrans"));
        self.translationPart8.maxTrans = {};
        self.translationPart8.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart8.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart8.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart8.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart8#transTime"), 2)*1000;
        self.translationPart8.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart8#touchTransLimit"), 10);
    end;
    local translationPartNode9 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart9#index"));
    if translationPartNode9 ~= nil then
        self.translationPart9 = {};
        self.translationPart9.node = translationPartNode9;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart9#minTrans"));
        self.translationPart9.minTrans = {};
        self.translationPart9.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart9.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart9.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart9#maxTrans"));
        self.translationPart9.maxTrans = {};
        self.translationPart9.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart9.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart9.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart9.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart9#transTime"), 2)*1000;
        self.translationPart9.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart9#touchTransLimit"), 10);
    end;

        self.baleTypes = {};
        local i = 0;
        while true do
           local key = string.format("vehicle.baleTypes.baleType(%d)", i);
           local t = getXMLString(xmlFile, key.."#fruitType");
           local filename = getXMLString(xmlFile, key.."#filename");
           if t==nil or filename==nil then
               break;
           end;

           local entry = {};
           entry.filename = filename;
           local desc = FruitUtil.fruitTypes[t];
           if desc ~= nil then
               self.baleTypes[desc.index] = entry;

               if self.defaultBaleType == nil then
                   self.defaultBaleType = entry;
               end;
           end;
           i = i +1;
       end;
       if self.defaultBaleType == nil then
           self.baleTypes = nil;
       end;



       self.baleLastPositionTime = 0;
       self.bales = {};
       self.speedViolationMaxTime = 2500;
       self.speedViolationTimer = self.speedViolationMaxTime;

	   self.beaLights = {};
       local i = 0;
       while true do
           local key = string.format("vehicle.beaLights.beaLight(%d)", i);
           if not hasXMLProperty(xmlFile, key) then
               break;
           end;
           local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
           local speed = Utils.getNoNil(getXMLFloat(xmlFile, key.."#speed"), 0.02);
           if node ~= nil then
               table.insert(self.beaLights, {node=node, speed=speed});
           end;
           i = i + 1;
       end;
       
    self.regimeMax = false;
    self.regimeMax2 = false;
    

end;
	
function Finisher:delete()
end;

function Finisher:readStream(streamId, connection)
       local isTurneOn = streamReadBool(streamId);
       local animTime = streamReadFloat32(streamId);
       Finisher.setRotorAnimTime(self, animTime);
       self:setIsTurneOn(isTurneOn, true);
       

   end;

   function Finisher:writeStream(streamId, connection)
       streamWriteBool(streamId, self.isTurneOn);
       streamWriteFloat32(streamId, self.animTime);
       

   end;

function Finisher:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Finisher:keyEvent(unicode, sym, modifier, isDown)

if self.isEntered and self.isMotorStarted then
	if sym == Input.KEY_KP_7 then
		self.translationMax4 = isDown;
		self.translationMax5 = isDown;
		self.translationMax6 = isDown;
		self.translationMax7 = isDown;
     end;

	if sym == Input.KEY_KP_4 then
		self.translationMin4 = isDown;
		self.translationMin5 = isDown;
		self.translationMin6 = isDown;
		self.translationMin7 = isDown;
	 end;

  end;

	 
end;

function Finisher:update(dt)


	if self.movingDirection == 1 or self.movingDirection == -1 then
		self.regimeMax = true;
    else
        self.regimeMax = false;

	end;

		if self.isMotorStarted then
			if self:getIsActiveForSound() then
               if self.motoSound ~= nil and not self.motoSoundEnabled  then
                   playSample(self.motoSound, 0, self.motoSoundVolume, 0);
                   self.motoSoundEnabled = true;
               end;
			end;
			local x,y,z = getWorldTranslation(self.regime);
			local a,b,c = getWorldTranslation(self.regime2);
			local benne = Utils.vector3Length(x-a, y-b, z-c);
            if self.motoSound ~= nil then
                setSamplePitch(self.motoSound, math.min(self.motoSoundPitchOffset + self.motoSoundPitchScale*math.abs(benne), self.motoSoundPitchMax));
            end;

		end;
		
	if self.regimeMax ~= nil then
		local x, y, z = getTranslation(self.translationPart8.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart8.maxTrans, self.translationPart8.minTrans, 3, self.translationPart8.transTime, dt, not self.regimeMax);
        setTranslation(self.translationPart8.node, unpack(newTrans));
	end;
	if self.regimeMax2 ~= nil then
		local x, y, z = getTranslation(self.translationPart9.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart9.maxTrans, self.translationPart9.minTrans, 3, self.translationPart9.transTime, dt, not self.regimeMax2);
        setTranslation(self.translationPart9.node, unpack(newTrans));
	end;

	
    if self.Go.lame2 ~= nil and self.Done.lame2 ~= false then
		self:anim("lame2", false);
	end;


    self.lame2Moving = 0;
    
     	for i, jointDesc in pairs(self.componentJoints) do
	   setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
	end;
	

		for k, roadpart in pairs(self.Roadparts) do
			-- checks if node on terrainDetail
			local x,y,z = getWorldTranslation(roadpart.node);
            local cultivatorChannel = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.cultivatorChannel, x, z, x, z, x, z);
			local ploughChannel = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.ploughChannel, x, z, x, z, x, z);
                if self.fillLevel > 0 then
				if self.movingDirection ~= 0 then
                if cultivatorChannel > 0 or ploughChannel > 0 then
				if   math.abs(self.speedViolationTimer - self.speedViolationMaxTime) <= 1 then
				        if self.translationMax3 then
							if self.lastSpeed*900 > 0.2 then
								if roadpart.LastCreatedGround == nil then
									roadpart.createRoad = true;

                                    										 Finisher.createBale(self, usedFruitType);
 					        			 local numBales = table.getn(self.bales);
    						             local bale = self.bales[numBales]
    						             Finisher.dropBale(self, 1);
								else
								    local nearestDistance = 0.8;
									local px, py, pz = getWorldTranslation(roadpart.node);
									local vx, vy, vz = getWorldTranslation(roadpart.LastCreatedGround);
									roadpart.distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
									if roadpart.distance > nearestDistance then
                                        roadpart.createRoad = true;

										 Finisher.createBale(self, usedFruitType);
 					        			 local numBales = table.getn(self.bales);
    						             local bale = self.bales[numBales]     
    						             Finisher.dropBale(self, 1);

									end;
								end;
                                end;

                                end;
                                end;
                                end;
					end;

			end;
			
			if roadpart.createRoad then
			
				local i3dPath = roadpart.enrobe;
				local GroundRoot = Utils.loadSharedI3DFile(i3dPath, self.baseDirectory);
				local GroundId = getChildAt(GroundRoot, 0);
				setRigidBodyType(GroundId, "None");
				link(getRootNode(), GroundId);
				delete(GroundRoot);
				local x,y,z = getWorldRotation(roadpart.node);
				setRotation(GroundId, x,y,z);
				local x,y,z = getWorldTranslation(roadpart.node);
				setTranslation(GroundId, x,y,z);

				local Ground = {};
				Ground.id = GroundId;



				roadpart.LastCreatedGround = GroundId;
				roadpart.createRoad = false;

				
			end;
		end;
		
				for k, roadpar in pairs(self.Roadpars) do
			-- checks if node on terrainDetail
			local x,y,z = getWorldTranslation(roadpar.node);
            local cultivatorChannel = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.cultivatorChannel, x, z, x, z, x, z);
			local ploughChannel = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.ploughChannel, x, z, x, z, x, z);
                if self.fillLevel > 0 then
				if self.movingDirection ~= 0 then
                if cultivatorChannel > 0 or ploughChannel > 0 then
				if   math.abs(self.speedViolationTimer - self.speedViolationMaxTime) <= 1 then
				        if self.translationMax3 then
							if self.lastSpeed*900 > 0.2 then
								if roadpar.LastCreatedGround == nil then
									roadpar.createRoad = true;

                                    										 Finisher.creatBale(self, usedFruitType);
 					        			 local numBales = table.getn(self.bales);
    						             local bale = self.bales[numBales]
    						             Finisher.droBale(self, 1);
								else
								    local nearestDistance = 0.8;
									local px, py, pz = getWorldTranslation(roadpar.node);
									local vx, vy, vz = getWorldTranslation(roadpar.LastCreatedGround);
									roadpar.distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
									if roadpar.distance > nearestDistance then
                                        roadpar.createRoad = true;

										 Finisher.creatBale(self, usedFruitType);
 					        			 local numBales = table.getn(self.bales);
    						             local bale = self.bales[numBales]
    						             Finisher.droBale(self, 1);

									end;
								end;
                                end;

                                end;
                                end;
                                end;
					end;
			end;

			if roadpar.createRoad then

				local i3dPath = roadpar.enrobe;
				local GroundRoot = Utils.loadSharedI3DFile(i3dPath, self.baseDirectory);
				local GroundId = getChildAt(GroundRoot, 0);
				setRigidBodyType(GroundId, "None");
				link(getRootNode(), GroundId);
				delete(GroundRoot);
				local x,y,z = getWorldRotation(roadpar.node);
				setRotation(GroundId, x,y,z);
				local x,y,z = getWorldTranslation(roadpar.node);
				setTranslation(GroundId, x,y,z);

				local Ground = {};
				Ground.id = GroundId;



				roadpar.LastCreatedGround = GroundId;
				roadpar.createRoad = false;


			end;
		end;
		
		for k, roadpa in pairs(self.Roadpas) do
			-- checks if node on terrainDetail
			local x,y,z = getWorldTranslation(roadpa.node);
            local cultivatorChannel = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.cultivatorChannel, x, z, x, z, x, z);
			local ploughChannel = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.ploughChannel, x, z, x, z, x, z);
                if self.fillLevel > 0 then
				if self.movingDirection ~= 0 then
                if cultivatorChannel > 0 or ploughChannel > 0 then
				if   math.abs(self.speedViolationTimer - self.speedViolationMaxTime) <= 1 then
				        if self.translationMax3 then
							if self.lastSpeed*900 > 0.2 then
								if roadpa.LastCreatedGround == nil then
									roadpa.createRoad = true;

                                    										 Finisher.creBale(self, usedFruitType);
 					        			 local numBales = table.getn(self.bales);
    						             local bale = self.bales[numBales]
    						             Finisher.dBale(self, 1);
								else
								    local nearestDistance = 0.8;
									local px, py, pz = getWorldTranslation(roadpa.node);
									local vx, vy, vz = getWorldTranslation(roadpa.LastCreatedGround);
									roadpa.distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
									if roadpa.distance > nearestDistance then
                                        roadpa.createRoad = true;

										 Finisher.creBale(self, usedFruitType);
 					        			 local numBales = table.getn(self.bales);
    						             local bale = self.bales[numBales]
    						             Finisher.dBale(self, 1);

									end;
								end;
                                end;

                                end;
                                end;
                                end;
					end;
			end;

			if roadpa.createRoad then

				local i3dPath = roadpa.enrobe;
				local GroundRoot = Utils.loadSharedI3DFile(i3dPath, self.baseDirectory);
				local GroundId = getChildAt(GroundRoot, 0);
				setRigidBodyType(GroundId, "None");
				link(getRootNode(), GroundId);
				delete(GroundRoot);
				local x,y,z = getWorldRotation(roadpa.node);
				setRotation(GroundId, x,y,z);
				local x,y,z = getWorldTranslation(roadpa.node);
				setTranslation(GroundId, x,y,z);

				local Ground = {};
				Ground.id = GroundId;



				roadpa.LastCreatedGround = GroundId;
				roadpa.createRoad = false;


			end;
		end;
		
  for k, roadp in pairs(self.Roadps) do
			-- checks if node on terrainDetail
			local x,y,z = getWorldTranslation(roadp.node);
            local cultivatorChannel = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.cultivatorChannel, x, z, x, z, x, z);
			local ploughChannel = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.ploughChannel, x, z, x, z, x, z);
                if self.fillLevel > 0 then
				if self.movingDirection ~= 0 then
                if cultivatorChannel > 0 or ploughChannel > 0 then
				if   math.abs(self.speedViolationTimer - self.speedViolationMaxTime) <= 1 then
				        if self.translationMax3 then
							if self.lastSpeed*900 > 0.2 then
								if roadp.LastCreatedGround == nil then
									roadp.createRoad = true;

										Finisher.creaBale(self, usedFruitType);
 					        			 local numBales = table.getn(self.bales);
    						             local bale = self.bales[numBales]
    						             Finisher.drBale(self, 1);

								else
								    local nearestDistance = 0.8;
									local px, py, pz = getWorldTranslation(roadp.node);
									local vx, vy, vz = getWorldTranslation(roadp.LastCreatedGround);
									roadp.distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
									if roadp.distance > nearestDistance then
                                        roadp.createRoad = true;

										 Finisher.creaBale(self, usedFruitType);
 					        			 local numBales = table.getn(self.bales);
    						             local bale = self.bales[numBales]
    						             Finisher.drBale(self, 1);

									end;
								end;
                                end;

                                end;
                                end;
                                end;
					end;
			end;

			if roadp.createRoad then

				local i3dPath = roadp.enrobe;
				local GroundRoot = Utils.loadSharedI3DFile(i3dPath, self.baseDirectory);
				local GroundId = getChildAt(GroundRoot, 0);
				setRigidBodyType(GroundId, "None");
				link(getRootNode(), GroundId);
				delete(GroundRoot);
				local x,y,z = getWorldRotation(roadp.node);
				setRotation(GroundId, x,y,z);
				local x,y,z = getWorldTranslation(roadp.node);
				setTranslation(GroundId, x,y,z);

				local Ground = {};
				Ground.id = GroundId;



				roadp.LastCreatedGround = GroundId;
				roadp.createRoad = false;


			end;
		end;
		
		  for k, road in pairs(self.Roads) do
			-- checks if node on terrainDetail
			local x,y,z = getWorldTranslation(road.node);
            local cultivatorChannel = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.cultivatorChannel, x, z, x, z, x, z);
			local ploughChannel = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.ploughChannel, x, z, x, z, x, z);
                if self.fillLevel > 0 then
				if self.movingDirection ~= 0 then
                if cultivatorChannel > 0 or ploughChannel > 0 then
				if   math.abs(self.speedViolationTimer - self.speedViolationMaxTime) <= 1 then
				        if self.translationMax3 then
							if self.lastSpeed*900 > 0.2 then
								if road.LastCreatedGround == nil then
									road.createRoad = true;

                                     										 Finisher.crBale(self, usedFruitType);
 					        			 local numBales = table.getn(self.bales);
    						             local bale = self.bales[numBales]
    						             Finisher.eBale(self, 1);
								else
								    local nearestDistance = 0.8;
									local px, py, pz = getWorldTranslation(road.node);
									local vx, vy, vz = getWorldTranslation(road.LastCreatedGround);
									road.distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
									if road.distance > nearestDistance then
                                        road.createRoad = true;

										 Finisher.crBale(self, usedFruitType);
 					        			 local numBales = table.getn(self.bales);
    						             local bale = self.bales[numBales]
    						             Finisher.eBale(self, 1);

									end;
								end;
                                end;

                                end;
                                end;
                                end;
					end;
			end;

			if road.createRoad then

				local i3dPath = road.enrobe;
				local GroundRoot = Utils.loadSharedI3DFile(i3dPath, self.baseDirectory);
				local GroundId = getChildAt(GroundRoot, 0);
				setRigidBodyType(GroundId, "None");
				link(getRootNode(), GroundId);
				delete(GroundRoot);
				local x,y,z = getWorldRotation(road.node);
				setRotation(GroundId, x,y,z);
				local x,y,z = getWorldTranslation(road.node);
				setTranslation(GroundId, x,y,z);

				local Ground = {};
				Ground.id = GroundId;



				road.LastCreatedGround = GroundId;
				road.createRoad = false;


			end;
		end;
				  for k, roa in pairs(self.Roas) do
			-- checks if node on terrainDetail
			local x,y,z = getWorldTranslation(roa.node);
            local cultivatorChannel = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.cultivatorChannel, x, z, x, z, x, z);
			local ploughChannel = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.ploughChannel, x, z, x, z, x, z);
                if self.fillLevel > 0 then
				if self.movingDirection ~= 0 then
                if cultivatorChannel > 0 or ploughChannel > 0 then
				if   math.abs(self.speedViolationTimer - self.speedViolationMaxTime) <= 1 then
				        if self.translationMax3 then
							if self.lastSpeed*900 > 0.2 then
								if roa.LastCreatedGround == nil then
									roa.createRoad = true;

                                    										 Finisher.cBale(self, usedFruitType);
 					        			 local numBales = table.getn(self.bales);
    						             local bale = self.bales[numBales]
    						             Finisher.fBale(self, 1);
								else
								    local nearestDistance = 0.8;
									local px, py, pz = getWorldTranslation(roa.node);
									local vx, vy, vz = getWorldTranslation(roa.LastCreatedGround);
									roa.distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
									if roa.distance > nearestDistance then
                                        roa.createRoad = true;

										 Finisher.cBale(self, usedFruitType);
 					        			 local numBales = table.getn(self.bales);
    						             local bale = self.bales[numBales]
    						             Finisher.fBale(self, 1);

									end;
								end;
                                end;

                                end;
                                end;
                                end;
					end;
			end;

			if roa.createRoad then

				local i3dPath = roa.enrobe;
				local GroundRoot = Utils.loadSharedI3DFile(i3dPath, self.baseDirectory);
				local GroundId = getChildAt(GroundRoot, 0);
				setRigidBodyType(GroundId, "None");
				link(getRootNode(), GroundId);
				delete(GroundRoot);
				local x,y,z = getWorldRotation(roa.node);
				setRotation(GroundId, x,y,z);
				local x,y,z = getWorldTranslation(roa.node);
				setTranslation(GroundId, x,y,z);

				local Ground = {};
				Ground.id = GroundId;



				roa.LastCreatedGround = GroundId;
				roa.createRoad = false;


			end;
		end;




    if self.translationMax3 then
    	for _, beaLight in pairs(self.beaLights) do
    		rotate(beaLight.node, 0, beaLight.speed*dt, 0);
        end;
	end;




	if self: getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.LOWER_IMPLEMENT) then
			self.rotationMaxRight = not self.rotationMaxRight;
			self.rotationMaxLeft = not self.rotationMaxLeft;
			self.rotationMaxRight2 = not self.rotationMaxRight2;
			self.rotationMaxLeft2 = not self.rotationMaxLeft2;
			self.translationMax = not self.translationMax;
			self.translationMax2 = not self.translationMax2;
		end;
		if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
			self.translationMax3 = not self.translationMax3;
			self.regimeMax2 = not self.regimeMax2;
		end;
		if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
               --self.isTurneOn = not self.isTurneOn;
               self:setIsTurneOn(not self.isTurneOn);
        end;
	end;
	

	       
		
	if self.translationMax ~= nil then
		local x, y, z = getTranslation(self.translationPart.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart.maxTrans, self.translationPart.minTrans, 3, self.translationPart.transTime, dt, not self.translationMax);
        setTranslation(self.translationPart.node, unpack(newTrans));
	end;
	if self.translationMax2 ~= nil then
		local x, y, z = getTranslation(self.translationPart2.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart2.maxTrans, self.translationPart2.minTrans, 3, self.translationPart2.transTime, dt, not self.translationMax2);
        setTranslation(self.translationPart2.node, unpack(newTrans));
	end;
	if self.translationMax3 ~= nil then
		local x, y, z = getTranslation(self.translationPart3.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart3.maxTrans, self.translationPart3.minTrans, 3, self.translationPart3.transTime, dt, not self.translationMax3);
        setTranslation(self.translationPart3.node, unpack(newTrans));
	end;
	local doTranslate = self.translationMax4 or self.translationMin4
		if self.translationMax4 ~= nil and doTranslate then
		local x, y, z = getTranslation(self.translationPart4.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart4.maxTrans, self.translationPart4.minTrans, 3, self.translationPart4.transTime, dt, not self.translationMax4);
        setTranslation(self.translationPart4.node, unpack(newTrans));
	end;
	local doTranslate = self.translationMax5 or self.translationMin5
		if self.translationMax5 ~= nil and doTranslate then
		local x, y, z = getTranslation(self.translationPart5.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart5.maxTrans, self.translationPart5.minTrans, 3, self.translationPart5.transTime, dt, not self.translationMax5);
        setTranslation(self.translationPart5.node, unpack(newTrans));
	end;
	local doTranslate = self.translationMax6 or self.translationMin6
		if self.translationMax6 ~= nil and doTranslate then
		local x, y, z = getTranslation(self.translationPart6.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart6.maxTrans, self.translationPart6.minTrans, 3, self.translationPart6.transTime, dt, not self.translationMax6);
        setTranslation(self.translationPart6.node, unpack(newTrans));
	end;
	local doTranslate = self.translationMax7 or self.translationMin7
		if self.translationMax7 ~= nil and doTranslate then
		local x, y, z = getTranslation(self.translationPart7.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart7.maxTrans, self.translationPart7.minTrans, 3, self.translationPart7.transTime, dt, not self.translationMax7);
        setTranslation(self.translationPart7.node, unpack(newTrans));
	end;
	if self.rotationPartRight ~= nil then
        local x, y, z = getRotation(self.rotationPartRight.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRight.maxRot, self.rotationPartRight.minRot, 3, self.rotationPartRight.rotTime, dt, not self.rotationMaxRight);
        setRotation(self.rotationPartRight.node, unpack(newRot));
    end;

    if self.rotationPartLeft ~= nil then
        local x, y, z = getRotation(self.rotationPartLeft.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartLeft.maxRot, self.rotationPartLeft.minRot, 3, self.rotationPartLeft.rotTime, dt, not self.rotationMaxLeft);
        setRotation(self.rotationPartLeft.node, unpack(newRot));
    end;
    	if self.rotationPartRight2 ~= nil then
        local x, y, z = getRotation(self.rotationPartRight2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRight2.maxRot, self.rotationPartRight2.minRot, 3, self.rotationPartRight2.rotTime, dt, not self.rotationMaxRight2);
        setRotation(self.rotationPartRight2.node, unpack(newRot));
    end;

    if self.rotationPartLeft2 ~= nil then
        local x, y, z = getRotation(self.rotationPartLeft2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartLeft2.maxRot, self.rotationPartLeft2.minRot, 3, self.rotationPartLeft2.rotTime, dt, not self.rotationMaxLeft2);
        setRotation(self.rotationPartLeft2.node, unpack(newRot));
    end;
    


    
    
end;

function Finisher:updateTick(dt)
       if self:getIsActive() then
           if self.isTurneOn then
               self.animTime = self.animTime + dt;
               Finisher.setRotorAnimTime(self, self.animTime);
           end;

       end;
end;

function Finisher:draw()

g_currentMission:addExtraPrintText("7/4  >> modifier largeur ")
g_currentMission:addExtraPrintText("B  >> mise en route");
g_currentMission:addExtraPrintText("V  >> partie avant");


end;



function Finisher:onLeave()
self.translationMax3 = false;
      if self.isClient then
           if self.motoSound ~= nil then
               stopSample(self.motoSound);
               self.motoSoundEnabled = false;

           end;

       end;
self.regimeMax2 = false;
end;
   
function Finisher:onActivate()
end;
   
function Finisher:onDeactivate()
self.translationMax3 = false;
self.regimeMax2 = false;

	if self.motoSound ~= nil and self.motoSoundEnabled then
        stopSample(self.motoSound);
        self.motoSoundEnabled = false;
        delete(self.motoSound);
    end;

end;

function Finisher:anim(varName, loopCheck)
	if self.Go[varName] == true and self.Done[varName] ~= false then
		local charId = getAnimCharacterSet(self.charId[varName]);
		local clipIndex = getAnimClipIndex(charId, self.clipIndex[varName]);
		assignAnimTrackClip(charId , 0, clipIndex);
		setAnimTrackLoopState(charId, 0, loopCheck);
		setAnimTrackSpeedScale(charId, 0, 1);
		enableAnimTrack(charId, 0);
		if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) and loopCheck == false then
			disableAnimTrack(charId, 0);
			self.Done[varName] = false;
			self.CheckDone[varName] = true;
		end;
	elseif self.Go[varName] == false and self.Done[varName] ~= false then
		local charId = getAnimCharacterSet(self.charId[varName]);
		local clipIndex = getAnimClipIndex(charId, self.clipIndex[varName]);
		if loopCheck == true then
			disableAnimTrack(charId, 0);
			self.Done[varName] = false;
		end;
		assignAnimTrackClip(charId , 0, clipIndex);
		setAnimTrackLoopState(charId, 0, loopCheck);
		setAnimTrackSpeedScale(charId, 0, -1);
		enableAnimTrack(charId, 0);
		if getAnimTrackTime(charId, 0) <= 0 then
			disableAnimTrack(charId, 0);
			self.Done[varName] = false;
			self.CheckDone[varName] = false;
		end;
	end;
end;

function Finisher:setIsTurneOn(isTurneOn, noEventSend)
       SetTurneOnEvent.sendEvent(self, isTurneOn, noEventSend)
       self.isTurneOn = isTurneOn;
   end;

   function Finisher.setRotorAnimTime(self, animTime)
       self.animTime = animTime;
       for i=1, table.getn(self.rotors) do
           local rotor = self.rotors[i].index;
           local rotorRot = self.rotors[i].speed*animTime;
           --rotate(rotor, 0, rotorRot, 0);
           setRotation(rotor, 0 , rotorRot, 0);
       end;
   end;
   
function Finisher.createBale(self, usedFruitType)

       local baleType = self.defaultBaleType;

       local fname = getUserProfileAppPath().."mods/finisher/routei.i3d";
       local Finisheroot = Utils.loadSharedI3DFile(fname);
       local baleId = getChildAt(Finisheroot, 0);
       setRigidBodyType(baleId, "None");
       link(self.Routea, baleId);
       delete(Finisheroot);
       
       local bale = {};
       bale.id = baleId;
       bale.time = 0;
       bale.filename = Utils.getFilename(baleType.filename, self.baseDirectory);
       bale.lastX, bale.lastY, bale.lastZ = getWorldTranslation(bale.id);
       table.insert(self.bales, bale);
       local i = table.getn(self.bales);
end;

function Finisher.creatBale(self, usedFruitType)

       local baleType = self.defaultBaleType;
       
       	local fname = getUserProfileAppPath().."mods/finisher/routei.i3d";
		local Finisheroot = Utils.loadSharedI3DFile(fname);
		local balId = getChildAt(Finisheroot, 0);
        setRigidBodyType(balId, "None");
        link(self.Routeb, balId);
        delete(Finisheroot);
        
       local bal = {};
       bal.id = balId;
       bal.time = 0;
       bal.filename = Utils.getFilename(baleType.filename, self.baseDirectory);
       bal.lastX, bal.lastY, bal.lastZ = getWorldTranslation(bal.id);
       table.insert(self.bales, bal);
       local i = table.getn(self.bales);
end;
        
function Finisher.creaBale(self, usedFruitType)

       local baleType = self.defaultBaleType;
        
        
        local fname = getUserProfileAppPath().."mods/finisher/routei.i3d";
		local Finisheroot = Utils.loadSharedI3DFile(fname);
		local baId = getChildAt(Finisheroot, 0);
        setRigidBodyType(baId, "None");
        link(self.Routed, baId);
        delete(Finisheroot);
        
       local ba = {};
       ba.id = baId;
       ba.time = 0;
       ba.filename = Utils.getFilename(baleType.filename, self.baseDirectory);
       ba.lastX, ba.lastY, ba.lastZ = getWorldTranslation(ba.id);
       table.insert(self.bales, ba);
       local i = table.getn(self.bales);
end;
        
function Finisher.creBale(self, usedFruitType)

       local baleType = self.defaultBaleType;
        
        local fname = getUserProfileAppPath().."mods/finisher/routei.i3d";
		local Finisheroot = Utils.loadSharedI3DFile(fname);
		local bId = getChildAt(Finisheroot, 0);
        setRigidBodyType(bId, "None");
        link(self.Routec, bId);
        delete(Finisheroot);
        
       local b = {};
       b.id = bId;
       b.time = 0;
       b.filename = Utils.getFilename(baleType.filename, self.baseDirectory);
       b.lastX, b.lastY, b.lastZ = getWorldTranslation(b.id);
       table.insert(self.bales, b);
       local i = table.getn(self.bales);
       
end;
        
function Finisher.crBale(self, usedFruitType)

       local baleType = self.defaultBaleType;
        
        local fname = getUserProfileAppPath().."mods/finisher/routei.i3d";
		local Finisheroot = Utils.loadSharedI3DFile(fname);
		local cId = getChildAt(Finisheroot, 0);
        setRigidBodyType(cId, "None");
        link(self.Routee, cId);
        delete(Finisheroot);
        
       local c = {};
       c.id = cId;
       c.time = 0;
       c.filename = Utils.getFilename(baleType.filename, self.baseDirectory);
       c.lastX, c.lastY, c.lastZ = getWorldTranslation(c.id);
       table.insert(self.bales, c);
       local i = table.getn(self.bales);

end;
        
function Finisher.cBale(self, usedFruitType)

       local baleType = self.defaultBaleType;
       
        local fname = getUserProfileAppPath().."mods/finisher/routei.i3d";
		local Finisheroot = Utils.loadSharedI3DFile(fname);
		local dId = getChildAt(Finisheroot, 0);
        setRigidBodyType(dId, "None");
        link(self.Routef, dId);
        delete(Finisheroot);
       


       local d = {};
       d.id = dId;
       d.time = 0;
       d.filename = Utils.getFilename(baleType.filename, self.baseDirectory);
       d.lastX, d.lastY, d.lastZ = getWorldTranslation(d.id);
       table.insert(self.bales, d);
       local i = table.getn(self.bales);
end;

function Finisher.dropBale(self, baleIndex)
       local bal = self.bales[baleIndex];
       local deltaRealTime = (self.time - self.baleLastPositionTime)/1000;
       local x,y,z = getWorldTranslation(bal.id);
       y = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z)+0.1;
       local rx,ry,rz = getWorldRotation(bal.id);
       --link(getRootNode(), bale.id);


       if self.isServer then
           local balObject = Bale:new(self.isServer, self.isClient);
           balObject:load(bal.filename, x,y,z,rx,ry,rz);
           balObject:register();

           local lx, ly, lz = bal.lastX, bal.lastY, bal.lastZ;
           setLinearVelocity(balObject.nodeId, (x-lx)/deltaRealTime, (y-ly)/deltaRealTime, (z-lz)/deltaRealTime);
       end;

       table.remove(self.bales, baleIndex);
       
       
end;

function Finisher.droBale(self, baleIndex)



       local ba = self.bales[baleIndex];
       local deltaRealTime = (self.time - self.baleLastPositionTime)/1000;
       local x,y,z = getWorldTranslation(ba.id);
       y = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z)+0.1;
       local rx,ry,rz = getWorldRotation(ba.id);
       --link(getRootNode(), bale.id);


       if self.isServer then
           local baObject = Bale:new(self.isServer, self.isClient);
           baObject:load(ba.filename, x,y,z,rx,ry,rz);
           baObject:register();

           local lx, ly, lz = ba.lastX, ba.lastY, ba.lastZ;
           setLinearVelocity(baObject.nodeId, (x-lx)/deltaRealTime, (y-ly)/deltaRealTime, (z-lz)/deltaRealTime);
       end;
       delete(ba.id);

       table.remove(self.bales, baleIndex);
       
end;


function Finisher.drBale(self, baleIndex)
       
       local b = self.bales[baleIndex];
       local deltaRealTime = (self.time - self.baleLastPositionTime)/1000;
       local x,y,z = getWorldTranslation(b.id);
       y = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z)+0.1;
       local rx,ry,rz = getWorldRotation(b.id);
       --link(getRootNode(), bale.id);


       if self.isServer then
           local bObject = Bale:new(self.isServer, self.isClient);
           bObject:load(b.filename, x,y,z,rx,ry,rz);
           bObject:register();

           local lx, ly, lz = b.lastX, b.lastY, b.lastZ;
           setLinearVelocity(bObject.nodeId, (x-lx)/deltaRealTime, (y-ly)/deltaRealTime, (z-lz)/deltaRealTime);
       end;

       table.remove(self.bales, baleIndex);
       
end;
       
       
function Finisher.dBale(self, baleIndex)



       
       local c = self.bales[baleIndex];
       local deltaRealTime = (self.time - self.baleLastPositionTime)/1000;
       local x,y,z = getWorldTranslation(c.id);
       y = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z)+0.1;
       local rx,ry,rz = getWorldRotation(c.id);
       --link(getRootNode(), bale.id);


       if self.isServer then
           local cObject = Bale:new(self.isServer, self.isClient);
           cObject:load(c.filename, x,y,z,rx,ry,rz);
           cObject:register();

           local lx, ly, lz = c.lastX, c.lastY, c.lastZ;
           setLinearVelocity(cObject.nodeId, (x-lx)/deltaRealTime, (y-ly)/deltaRealTime, (z-lz)/deltaRealTime);
       end;
       delete(c.id);
       table.remove(self.bales, baleIndex);
       
end;
       
       
function Finisher.eBale(self, baleIndex)
       
       local d = self.bales[baleIndex];
       local deltaRealTime = (self.time - self.baleLastPositionTime)/1000;
       local x,y,z = getWorldTranslation(d.id);
       y = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z)+0.1;
       local rx,ry,rz = getWorldRotation(d.id);
       --link(getRootNode(), bale.id);


       if self.isServer then
           local dObject = Bale:new(self.isServer, self.isClient);
           dObject:load(d.filename, x,y,z,rx,ry,rz);
           dObject:register();

           local lx, ly, lz = d.lastX, d.lastY, d.lastZ;
           setLinearVelocity(dObject.nodeId, (x-lx)/deltaRealTime, (y-ly)/deltaRealTime, (z-lz)/deltaRealTime);
       end;

       table.remove(self.bales, baleIndex);
       
end;


function Finisher.fBale(self, baleIndex)


       local bale = self.bales[baleIndex];
       local deltaRealTime = (self.time - self.baleLastPositionTime)/1000;
       local x,y,z = getWorldTranslation(bale.id);
       y = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z)+0.1;
       local rx,ry,rz = getWorldRotation(bale.id);
       --link(getRootNode(), bale.id);


       if self.isServer then
           local baleObject = Bale:new(self.isServer, self.isClient);
           baleObject:load(bale.filename, x,y,z,rx,ry,rz);
           baleObject:register();

           local lx, ly, lz = bale.lastX, bale.lastY, bale.lastZ;
           setLinearVelocity(baleObject.nodeId, (x-lx)/deltaRealTime, (y-ly)/deltaRealTime, (z-lz)/deltaRealTime);
       end;
       delete(bale.id);
       table.remove(self.bales, baleIndex);


end;
